<?php
/**
 * 微信付款到零钱
 */

namespace payment\wechat;

class WechatTransfers
{
    const TRANSFERS_URL = 'https://api.mch.weixin.qq.com/v3/transfer/batches';

    public function transfers($batch_name, $detail_list)
    {
        $pars                         = [];
        $pars['appid']                = config('wxconfig.appId');//直连商户的appid
        $pars['out_batch_no']         = getUniId();//商户系统内部的商家批次单号，要求此参数只能由数字、大小写字母组成，在商户系统内部唯一
        $pars['batch_name']           = $batch_name;//该笔批量转账的名称
        $pars['batch_remark']         = $batch_name;//转账说明，UTF8编码，最多允许32个字符
        $pars['total_amount']         = array_sum(array_column($detail_list, 'transfer_amount'));//转账总金额 单位为“分”
        $pars['total_num']            = count($detail_list);//转账总笔数
        $pars['transfer_detail_list'] = $detail_list;
        $token                        = $this->getToken($pars);//获取token
        $res                          = $this->https_request(self::TRANSFERS_URL, json_encode($pars), $token);//发送请求
        $resArr                       = json_decode($res, true);
        return $resArr;
        //成功返回
        // array(3) {
        //   ["batch_id"] => string(40) "1030001016101247194272022062900873000000"
        //   ["create_time"] => string(25) "2022-06-29T10:21:30+08:00"
        //   ["out_batch_no"] => string(16) "sjzz202206291647001"
        // }
    }

    private function https_request($url, $data = null, $token)
    {
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, (string)$url);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);
        if (!empty($data)) {
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        }
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        //添加请求头
        $headers = [
            'Authorization:WECHATPAY2-SHA256-RSA2048 ' . $token,
            'Accept: application/json',
            'Content-Type: application/json; charset=utf-8',
            'User-Agent:Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36',
        ];
        if (!empty($headers)) {
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        }
        $output = curl_exec($curl);
        curl_close($curl);
        return $output;
    }

    private function getToken($pars)
    {
        // $url = 'https://api.mch.weixin.qq.com/v3/certificates';
        $url         = 'https://api.mch.weixin.qq.com/v3/transfer/batches';
        $http_method = 'POST';//请求方法（GET,POST,PUT）
        $timestamp   = time();//请求时间戳
        $url_parts   = parse_url($url);//获取请求的绝对URL
        $nonce       = $timestamp . rand('10000', '99999');//请求随机串
        $body        = json_encode((object)$pars);//请求报文主体
        $stream_opts = [
            "ssl" => [
                "verify_peer"      => false,
                "verify_peer_name" => false,
            ],
        ];

//        $apiclient_cert_path = 'https://' . $_SERVER['HTTP_HOST'] . '/uploads/apiclient/apiclient_cert.pem';
//        $apiclient_key_path  = 'https://' . $_SERVER['HTTP_HOST'] . '/uploads/apiclient/apiclient_key.pem';
        $apiclient_key_path = root_path('extend/payment/cert') . 'apiclient_key.pem';

//        $apiclient_cert_arr = openssl_x509_parse(file_get_contents($apiclient_cert_path,false, stream_context_create($stream_opts)));
//        $serial_no          = $apiclient_cert_arr['serialNumberHex'];//证书序列号
        $serial_no       = config('wxconfig.serial');//证书序列号
        $mch_private_key = file_get_contents($apiclient_key_path, false, stream_context_create($stream_opts));//密钥
        $merchant_id     = config('wxconfig.payMchId');//商户id
        $canonical_url   = ($url_parts['path'] . (!empty($url_parts['query']) ? "?${url_parts['query']}" : ""));
        $message         = $http_method . "\n" .
            $canonical_url . "\n" .
            $timestamp . "\n" .
            $nonce . "\n" .
            $body . "\n";
        openssl_sign($message, $raw_sign, $mch_private_key, 'sha256WithRSAEncryption');
        $sign  = base64_encode($raw_sign);//签名
        $token = sprintf('mchid="%s",nonce_str="%s",timestamp="%d",serial_no="%s",signature="%s"',
            $merchant_id, $nonce, $timestamp, $serial_no, $sign);//微信返回token
        return $token;
    }

    /**
     * 转账明细列表
     */
    public function getDetailList($out_trade_no, $money, $batch_name, $openid)
    {
        return [
            'out_detail_no'   => $out_trade_no,
            'transfer_amount' => intval($money * 100),
            'transfer_remark' => $batch_name,
            'openid'          => $openid,
        ];
    }
}